function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["label", "list", "uploading", "onChoose", "onDelete", "onClick", "uploadProps", "itemProps"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// require (PrototypeString.js), 使用了getSuffix
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import locale from "./../locale";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Attach = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var label = _ref.label,
    list = _ref.list,
    uploading = _ref.uploading,
    onChoose = _ref.onChoose,
    onDelete = _ref.onDelete,
    onClick = _ref.onClick,
    uploadProps = _ref.uploadProps,
    itemProps = _ref.itemProps,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });

  // 获取附件类型图标
  function getIcon(src) {
    var suffix = typeof src === 'string' ? src.getSuffix() : null;
    if (!suffix) return 'unknown';
    if (suffix.indexOf('?') !== -1) {
      suffix = suffix.substring(0, suffix.indexOf('?'));
    }
    if ('RM,RMVB,MP4,3GP,AVI,MKV,WMV,MPG,VOB,FLV'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'video';
    }
    if ('WAVE,MPEG,MP3,MPEG-4,MIDI,WMA,VQF,AMR,APE,FLAC,AAC'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'audio';
    }
    if ('JPG,JPEG,WEBP,GIF,PNG,TIF,BMP'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'pic';
    }
    if ('RAR,ZIP'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'pack';
    }
    if ('DOC,DOCX'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'word';
    }
    if ('XSL,EXCEL'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'excel';
    }
    if ('PPT'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'ppt';
    }
    if ('PDF'.indexOf(suffix.toUpperCase()) !== -1) {
      return 'pdf';
    }
    return 'unknown';
  }
  function handleClick(e) {
    var target = e.target;
    if (target.classList.contains('attach-item')) {
      // 点击一行
      var index = target.getAttribute('data-index');
      if (index && onClick) onClick(e, list[index].src, [list[index]], Number(index));
    } else if (target.classList.contains('attach-item-delete')) {
      // 点击删除
      var _index = target.parentNode.getAttribute('data-index');
      if (_index && onDelete) onDelete(e, list[_index].src, [list[_index]], Number(_index));
    }
  }
  // file框选择
  function handleFileChange(e) {
    if (onChoose) onChoose(e);
    e.target.value = ''; // 防止选择重复图片时不触发
    e.stopPropagation();
  }

  // 获取Loading
  function getUploadingDOM() {
    if (!uploading) return null;
    if (typeof uploading === 'boolean') {
      return /*#__PURE__*/_jsx("div", {
        className: "attach-upload-loading",
        children: /*#__PURE__*/_jsx("div", {
          className: "attach-upload-loading-icon",
          children: /*#__PURE__*/_jsx("svg", {
            viewBox: "25 25 50 50",
            children: /*#__PURE__*/_jsx("circle", {
              cx: "50",
              cy: "50",
              r: "20"
            })
          })
        })
      });
    }
    return uploading;
  }
  return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, props), {}, {
    className: "attach".concat(uploading ? ' uploading' : '').concat(props.className ? ' ' + props.className : ''),
    onClick: handleClick,
    ref: rootRef,
    children: [onChoose && /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, uploadProps), {}, {
      className: "attach-upload".concat(uploadProps !== null && uploadProps !== void 0 && uploadProps.className ? ' ' + uploadProps.className : ''),
      children: [/*#__PURE__*/_jsx("input", {
        type: "file",
        name: "uploadAttach",
        onChange: handleFileChange
      }), /*#__PURE__*/_jsx("i", {
        className: "attach-upload-icon"
      }), getUploadingDOM(), /*#__PURE__*/_jsx("div", {
        className: "attach-upload-label",
        children: label || locale('附件', 'attach')
      })]
    })), list && list.length > 0 && list.map(function (item, index) {
      return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({
        "data-index": index,
        className: "attach-item".concat(item.className ? ' ' + item.className : ''),
        style: item.style || {}
      }, itemProps), {}, {
        children: [/*#__PURE__*/_jsx("i", {
          className: "icon attach-item-type ".concat(getIcon(item.src))
        }), /*#__PURE__*/_jsx("div", {
          className: "attach-item-label",
          children: item.name || item.src
        }), onDelete && /*#__PURE__*/_jsx("i", {
          className: "attach-item-delete"
        }), item.children]
      }), index);
    })]
  }));
});
export default Attach;