import { getActiveKey, getDateDisplayValue } from "./../utils";

// 显示名称
function getRangeDisplayValue(_ref) {
  var ranges = _ref.ranges,
    type = _ref.type,
    format = _ref.format,
    value = _ref.value,
    separator = _ref.separator;
  if (!Array.isArray(value) || value.length !== 2) {
    return '';
  }
  var start = value[0];
  var end = value[1];
  if (Object.isDate(start) === false || Object.isDate(end) === false) {
    return '';
  }
  var displayValue = [];

  // 显示别名
  var activeKey = getActiveKey(value, ranges, {
    format: format
  });
  if (activeKey) {
    return activeKey;
  }

  // 显示日期
  displayValue.push(getDateDisplayValue({
    type: type,
    format: format,
    value: start
  }));
  displayValue.push(getDateDisplayValue({
    type: type,
    format: format,
    value: end
  }));
  return displayValue.join(separator || ' ~ ');
}
export default getRangeDisplayValue;