function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["style", "text", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import Instance from "./instance.js";

// 生成二维码
import { jsx as _jsx } from "react/jsx-runtime";
var QRCode = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var style = _ref.style,
    text = _ref.text,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var rootRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  useEffect(function () {
    if (instance.current) return;
    instance.current = new Instance(rootRef.current, {
      text: text || '',
      width: Object.getUnitNum((style === null || style === void 0 ? void 0 : style.width) || 230),
      height: Object.getUnitNum((style === null || style === void 0 ? void 0 : style.width) || 230),
      colorDark: (style === null || style === void 0 ? void 0 : style.color) || '#000000',
      colorLight: (style === null || style === void 0 ? void 0 : style.backgroundColor) || '#ffffff',
      correctLevel: Instance.CorrectLevel.M // L,M,Q,H
    });
    // eslint-disable-next-line
  }, []);
  useEffect(function () {
    if (!instance.current || !text) return;
    var width = Object.getUnitNum((style === null || style === void 0 ? void 0 : style.width) || 0);
    var height = Object.getUnitNum((style === null || style === void 0 ? void 0 : style.height) || 0);
    var color = style === null || style === void 0 ? void 0 : style.color;
    var backgroundColor = style === null || style === void 0 ? void 0 : style.backgroundColor;
    if (width) instance.current._htOption.width = width;
    if (height) instance.current._htOption.height = height;
    if (color) instance.current._htOption.colorDark = color;
    if (backgroundColor) instance.current._htOption.colorLight = backgroundColor;
    instance.current.makeCode(text);
    // eslint-disable-next-line
  }, [text]);
  if (!text) return null;
  return /*#__PURE__*/_jsx("span", _objectSpread(_objectSpread({
    style: style
  }, props), {}, {
    className: "qrcode".concat(props.className ? ' ' + props.className : ''),
    ref: rootRef,
    children: children
  }));
});
export default QRCode;