function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "content", "animation", "style", "maskProps", "visible", "maskClosable", "onVisibleChange", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useEffect } from 'react';
import { createPortal } from 'react-dom';
import Utils from "./Utils";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Popup = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    content = _ref.content,
    animation = _ref.animation,
    style = _ref.style,
    _ref$maskProps = _ref.maskProps,
    maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
    visible = _ref.visible,
    _ref$maskClosable = _ref.maskClosable,
    maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
    onVisibleChange = _ref.onVisibleChange,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  // 构建动画
  var position = Utils.getAnimationPosition(animation);
  var dataAnimation = Utils.getDataAnimation(animation);

  // 点击遮罩
  function handleMaskClick(e) {
    if (maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
    e.stopPropagation();
  }

  // 箭头颜色: 根据style中的backgroundColor和borderColor
  var arrowStyle = null;
  var arrowOuterStyle = null;
  var backgroundColor = style === null || style === void 0 ? void 0 : style.backgroundColor;
  var borderColor = style === null || style === void 0 ? void 0 : style.borderColor;
  // 从下往上弹
  if (position.indexOf('bottom') === 0) {
    arrowStyle = backgroundColor ? {
      borderTopColor: backgroundColor
    } : null;
    arrowOuterStyle = borderColor ? {
      borderTopColor: borderColor
    } : null;
  }
  // 从上往下弹
  else {
    arrowStyle = backgroundColor ? {
      borderBottomColor: backgroundColor
    } : null;
    arrowOuterStyle = borderColor ? {
      borderBottomColor: borderColor
    } : null;
  }
  return /*#__PURE__*/createPortal( /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, maskProps), {}, {
    className: "mask tooltip-mask".concat(maskProps.className ? ' ' + maskProps.className : '').concat(visible ? ' active' : ''),
    onClick: handleMaskClick,
    ref: ref,
    children: /*#__PURE__*/_jsxs("div", {
      className: "popup-animation tooltip tooltip-bottom".concat(position ? ' ' + position : '').concat(props.className ? ' ' + props.className : '').concat(visible ? ' active' : ''),
      style: style,
      "data-animation": dataAnimation,
      children: [/*#__PURE__*/_jsx("div", {
        className: "tooltip-content",
        children: content
      }), /*#__PURE__*/_jsx("div", {
        className: "tooltip-arrow-outer",
        style: arrowOuterStyle
      }), /*#__PURE__*/_jsx("div", {
        className: "tooltip-arrow",
        style: arrowStyle
      })]
    })
  })), portal || document.getElementById('root') || document.body);
});
export default Popup;